escript::AbstractReducer Class Referenceabstract

`#include <AbstractReducer.h>`

Inheritance diagram for escript::AbstractReducer:

## Public Member Functions

virtual | ~AbstractReducer ()
virtual bool | valueCompatible (boost::python::object v)=0
virtual bool | reduceLocalValue (boost::python::object v, std::string &errstring)=0
virtual void | reset ()=0
virtual std::string | description ()=0
virtual bool | checkRemoteCompatibility (JMPI &mpi_info, std::string &errstring)=0
virtual void | setDomain (Domain_ptr dom)
virtual bool | reduceRemoteValues (MPI_Comm &comm)=0
bool | hasValue ()
virtual bool | canClash ()
virtual bool | recvFrom (int localid, int source, JMPI &mpiinfo)=0
virtual bool | sendTo (int localid, int target, JMPI &mpiinfo)=0
virtual double | getDouble ()
virtual boost::python::object | getPyObj ()=0
virtual void | newRunJobs ()
virtual void | clear ()
virtual void | copyValueFrom (boost::shared_ptr< AbstractReducer > &src)=0

## Protected Attributes

bool | valueadded
bool | had_an_export_this_round

## Static Protected Attributes

static const int | PARAMTAG =120567

## Constructor & Destructor Documentation

## ~AbstractReducer()

virtual escript::AbstractReducer::~AbstractReducer | ( |  | ) |

inline virtual

## Member Function Documentation

## canClash()

bool escript::AbstractReducer::canClash | ( |  | ) |

virtual

Reimplemented in escript::MPIScalarReducer, and escript::MPIDataReducer.

## checkRemoteCompatibility()

virtual bool escript::AbstractReducer::checkRemoteCompatibility | ( | JMPI & | mpi_info,
|  | std::string & | errstring
| ) |  |

pure virtual

Implemented in escript::MPIScalarReducer, escript::NonReducedVariable, and escript::MPIDataReducer.

## clear()

void escript::AbstractReducer::clear | ( |  | ) |

virtual

References valueadded.

## copyValueFrom()

virtual void escript::AbstractReducer::copyValueFrom | ( | boost::shared_ptr< AbstractReducer > & | src | ) |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## description()

virtual std::string escript::AbstractReducer::description | ( |  | ) |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## getDouble()

double escript::AbstractReducer::getDouble | ( |  | ) |

virtual

Reimplemented in escript::NonReducedVariable, and escript::MPIScalarReducer.

## getPyObj()

virtual boost::python::object escript::AbstractReducer::getPyObj | ( |  | ) |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## hasValue()

bool escript::AbstractReducer::hasValue | ( |  | ) |

References valueadded.

## newRunJobs()

void escript::AbstractReducer::newRunJobs | ( |  | ) |

virtual

Reimplemented in escript::MPIScalarReducer, and escript::MPIDataReducer.

References had_an_export_this_round.

## recvFrom()

virtual bool escript::AbstractReducer::recvFrom | ( | int | localid,
|  | int | source,
|  | JMPI & | mpiinfo
| ) |  |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## reduceLocalValue()

virtual bool escript::AbstractReducer::reduceLocalValue | ( | boost::python::object | v,
|  | std::string & | errstring
| ) |  |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## reduceRemoteValues()

virtual bool escript::AbstractReducer::reduceRemoteValues | ( | MPI_Comm & | comm | ) |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## reset()

virtual void escript::AbstractReducer::reset | ( |  | ) |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## sendTo()

virtual bool escript::AbstractReducer::sendTo | ( | int | localid,
|  | int | target,
|  | JMPI & | mpiinfo
| ) |  |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## setDomain()

virtual void escript::AbstractReducer::setDomain | ( | Domain_ptr | dom | ) |

inline virtual

Reimplemented in escript::NonReducedVariable, escript::MPIDataReducer, and escript::MPIScalarReducer.

## valueCompatible()

virtual bool escript::AbstractReducer::valueCompatible | ( | boost::python::object | v | ) |

pure virtual

Implemented in escript::NonReducedVariable, escript::MPIScalarReducer, and escript::MPIDataReducer.

## Member Data Documentation

## had_an_export_this_round

bool escript::AbstractReducer::had_an_export_this_round

protected

Referenced by newRunJobs().

## PARAMTAG

const int escript::AbstractReducer::PARAMTAG =120567

static protected

Referenced by escript::MPIDataReducer::recvFrom(), escript::MPIScalarReducer::recvFrom(), escript::MPIDataReducer::sendTo(), and escript::MPIScalarReducer::sendTo().

## valueadded

bool escript::AbstractReducer::valueadded

protected

Referenced by clear(), escript::MPIDataReducer::copyValueFrom(), escript::MPIScalarReducer::copyValueFrom(), escript::NonReducedVariable::copyValueFrom(), escript::MPIDataReducer::getCompatibilityInfo(), escript::MPIDataReducer::groupSend(), hasValue(), escript::MPIDataReducer::MPIDataReducer(), escript::MPIScalarReducer::MPIScalarReducer(), escript::NonReducedVariable::NonReducedVariable(), escript::MPIDataReducer::reduceLocalValue(), escript::MPIScalarReducer::reduceLocalValue(), escript::NonReducedVariable::reduceLocalValue(), escript::MPIDataReducer::reset(), escript::MPIScalarReducer::reset(), escript::NonReducedVariable::reset(), and escript::MPIDataReducer::sendTo().

The documentation for this class was generated from the following files:

- AbstractReducer.h
- AbstractReducer.cpp